import { SelectQueryBuilder } from '../../../utils/query-builder/SelectQueryBuilder';
export declare class Board {
    name: string;
    id: number;
    unread: boolean;
    category: string;
    flag: string;
    title: string;
    users: string;
    admin: string;
    folder: boolean;
    divider: boolean;
    /**
     * @deprecated
     */
    readonly bn: number;
    /**
     * @deprecated
     */
    readonly boardname: string;
    /**
     * @deprecated
     */
    readonly read: boolean;
    constructor(name?: string);
    static fromLine(line: string): Board;
    static fromClassLine(line: string): Board;
    static select(bot: any): SelectQueryBuilder<Board>;
}
export declare enum WhereType {
    Entry = "entry",
    Prefix = "prefix",
    Offset = "offset",
    Offsets = "offsets"
}
export declare enum Entry {
    Class = "class",
    Favorite = "favorite",
    Hot = "hot"
}
export declare class BoardSelectQueryBuilder extends SelectQueryBuilder<Board> {
    private bot;
    private entry;
    private prefix;
    private offsets;
    constructor(bot: any);
    where(type: WhereType, condition: any): this;
    get(): Promise<Board[]>;
    getOne(): Promise<Board | undefined>;
    private getByPrefix;
}
export default Board;
